; Q68 Keyboard polling	  1.02 (c) 2016-2023 W. Lenerz
;
; 2020-03-30	1.01	use possible delay loop ; apparently some keyboard adapters (usb->ps/2) do not respect the
;			ps/2 protocol : instead of waiting for the signal that a new byte may be sent, they just
;			wait a bit (apparently for a variable period of time) and then send another byte.

	section kbdint

	xdef	kbd_read

	xref	kbd_at102cvt
	xref	kbd_poll

	include 'dev8_keys_sys'
	include 'dev8_keys_q68'
	include 'dev8_keys_hwt'
	include 'dev8_smsq_kbd_keys'
	include 'dev8_keys_k'
	include 'dev8_keys_con'
	include 'dev8_keys_chn'

;+++
; This routine handles keyboard polling. The polling "server" is set up in
; smsq_q68_kbd_initi_asm
;---
kbd_read
	tst.b	sys_ps2(a6)
	bne.s	kbdi_rts

	btst	#kbd.rcv,kbd_status	; any keyboard data?
	beq.s	kbdi_exit		; ... no
rd_kbd	moveq	#0,D0
	move.b	kbd_code,d0		; IBM keycode
	st	kbd_unlock		; acknowledge key receipt
					; this should clear the kbd.rcv bit in kbd_status
	tst.b	kb_err(a3)		; strip queue on error?
	bgt.s	kbdi_exit		; ... yes

process bsr	kbd_at102cvt		; process key code
kbdi_exit
	jmp	kbd_poll		; handle keystroke(s)

kbdi_rts
	rts

	end
