; Q68 SER PAR PRT device initialisation  1.01  2017-2023  W. Lenerz
;
; based on
;
; Q68 SER PAR PRT device initialisation  V2.10	  1999  Tony Tebby
;
; 2023.02.18	v1.01 (wl) Interrupts handled by one interrupt routine, linked
;		in directly in the SER linkage block. Removed reference to
;		q68_ser_link. No poll for carrier detect timout (wl)

	section spp

	xdef	q68_spp_init

	xref	spp_init
	xref	spp_defs

	xref	q68_pardef
	xref	q68_serdef
	xref	spp_rxser
	xref	spp_txser

	include 'dev8_mac_vecx'
	include 'dev8_keys_qdos_sms'

;+++
; SPP driver initialisation.
;
;	a1-a3  scratch
;	status return standard
;---
q68_spp_init
	lea	q68_par,a1
	lea	q68_ser,a2
	lea	spp_defs,a1		; do not set a poll routine o check for
	clr.w	10(a1)			; a carrier detect timout.
	jsr	spp_init		; setup ports

; link in the interrupt routine directly (I don't want to go throught the hassle
; of using the istable in ser_asm).
; There is just one single interrupt routine which handles RX and then TX
; for all ports. This might seem cumbersome (why try to TX if the interrupt was
; for RX) but since there is only ONE external interrup tfor everything, all of
; the external interrupt routines will get called anyway.
; I might just as well do RX and TX in one single go, then.

	move.l	a3,a0			; link location
	lea	spp_rxser,a1		; external interrupt address
	move.l	a1,4(a0)		; set it in linkage area
	moveq	#sms.lexi,d0		; link in interrupt routine
	trap	#1
	rts

		    
q68_par
	vec	q68_pardef		; PAR driver definition
	novec
q68_ser
	vec	q68_serdef		; SER driver definition
	novec

	end
