; Qimsi PS2 Keyboard polling  v. 1.00  (c) 2023 W. Lenerz (based on my Q68 code)

	section ps2

	xdef	ps2_poll

	xref	ps2_link
	xref	ps2_at102cvt
	xref	ps2_read

	include 'dev8_keys_sys'
	include 'dev8_keys_hwt'
	include 'dev8_smsq_kbd_keys'
	include 'dev8_keys_k'
	include 'dev8_keys_con'
	include 'dev8_keys_chn'
	include 'dev8_smsq_qimsi_ps2_keys'

;+++
;
; This routine handles keyboard polling for PS2 kbd.
; d7 c p   reply from IPC
; a1 c p   ql keyboard linkage
; a3 c p   ql keyboard linkage (same as a1)
;
;---

ps2_poll
	move.l	ps2_link(pc),a3 	; get ps2 kbd linkage
	btst	#kbd.rcv,kbd_status	; any keyboard data?
	beq.s	kbdi_exit		; ... no, process lingering
					
rd_kbd
	moveq	#0,D0
	move.b	kbd_code,d0		; IBM keycode
	tst.b	kbd_unlock		; acknowledge key receipt

	tst.b	kb_err(a3)		; strip queue on error?
	bgt.s	kbdi_exit		; ... yes

process
	bsr	ps2_at102cvt		; process key code

kbdi_exit
	jsr	ps2_read		; handle keystroke(s)
kbdi_out
	rts



	end
